/// @file
////////////////////////////////////////////////////////////////////////////////
///
/// Copyright (C) 2009      University of Toronto
///
////////////////////////////////////////////////////////////////////////////////
///
///  module     : util
///
///  author     : lessig@dgp.toronto.edu
///
///  project    : Spherical Harmonics rotation
///
///  description: Core Spherical Harmonics functionality
///
///  license    : See README for details.
///
////////////////////////////////////////////////////////////////////////////////

#ifndef _CONFIG_H_
#define _CONFIG_H_

// includes, generic
#include <cstdlib>
#include <iostream>
#include <vector>

// Constants
#define PI  3.1415926535897932384626433832795
#define EPSILON  10E-15

#ifdef DEBUG                                                         
#define DEBUG_ASSERT( cond, class_name, func_name, msg)                   \
if( ! (cond)) {                                                           \
    std::cerr << __FILE__ << "::" << __LINE__ << " :: "                   \
              << class_name << "::" << func_name << " :: "                \
              << msg << std::endl;                                        \
     exit(0);                                                             \
  }                                                                  
#else
#define DEBUG_ASSERT( cond, class_name, func_name, msg)                     
#endif

// convenience typedefs
typedef  std::vector<double>        Vec;
typedef  std::pair<double,double>   LambdaType;
typedef  std::vector< LambdaType >  LambdaVec;

#endif // _CONFIG_H_

