/*************************************/
/* MEPOM 0.1                         */
/* Fichier: gaunt.h                  */
/* Version: 0.1                      */
/* Date:   Avril 2005                */
/* Auteur:  Didier Pinchon           */
/*************************************/
#ifndef GAUNT_H
#define GAUNT_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <limits.h>

typedef struct S_GAUNT_COEFFS {
   int lmax;
   int len;
   double **gaunt;
} Gaunt_Coeffs;

typedef struct S_GAUNT_COEFFS_3 {
   int lmax;
   int len0;
   int len3;
   double *coef0;
   double **w3j;
} Gaunt_Coeffs_3;

/* util_gaunt.c */
extern int imax(int,int);
extern int imin(int,int);
extern int iceil(int,int);
extern unsigned long fN1(int l);
extern unsigned long fM1(int l);
extern unsigned long fN2(int l);
extern unsigned long fN3bar(int l);
extern unsigned long fN3(int l);

extern int istriangle(int l1,int l2,int l3);

/* gaunt1.c */
extern Gaunt_Coeffs *init_gaunt_coeffs1(int lmax);
extern void free_Gaunt_Coeffs(Gaunt_Coeffs *GAUNT);
extern double gaunt1(int l1, int l2, int l3, int m1, int m2, int m3, Gaunt_Coeffs *GAUNT);

/* gaunt2.c */
extern Gaunt_Coeffs *init_gaunt_coeffs2(int lmax);
extern double gaunt2(int l1, int l2, int l3, int m1, int m2, int m3, Gaunt_Coeffs *GAUNT);

/* gaunt3.c */
extern Gaunt_Coeffs_3 *init_gaunt_coeffs3(int lmax);
extern double gaunt3(int l1, int l2, int l3, int m1, int m2, int m3, Gaunt_Coeffs_3 *GAUNT);

#endif /* GAUNT_H */
