/*************************************/
/* Fichier: rotation.h               */
/* Version: 0.1                      */
/* Date:   Septembre 2006            */
/* Auteur:                           */
/*************************************/
#ifndef ROTATION_H
#define ROTATION_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <gsl_matrix.h>
#include <gsl_blas.h>

typedef struct S_MATL {
   int lmax;
   gsl_matrix **lmat;
} MatL;

/* matl.c */
extern MatL *matl_calloc(int lmax);
extern void  matl_free(MatL *matl);
extern int   matl_product(const MatL *matl1, const MatL *matl2, MatL *matres);
extern int   matl_product_symm(CBLAS_SIDE_t Side,const MatL *matl1, const MatL *matl2, MatL *matres);
extern int   matl_product_symm_n(CBLAS_SIDE_t Side,const MatL *matl1, const MatL *matl2, MatL *matres, const unsigned int max_band);

/* rotation */

// read precomputed matrix data (for rotation around the Y axis)
extern MatL *read_matJ(int lmax, const char* fname);
// perform rotation around Z axis, left
extern int   matl_product_Zalpha_left(const MatL *matl1, const double alpha,MatL *res);
// perform rotation around Z axis, right
extern int   matl_product_Zalpha_right(const MatL *matl1, const double alpha,MatL *res);
// perform rotation by (alpha,beta,gamma)
extern int   matl_rotation(int lmax,double alpha, double beta, double gamma,MatL *res,const MatL *matj);
extern int   matl_rotation_opt(int lmax,double alpha, double beta, double gamma,MatL *res, const MatL *matj, const MatL* mat_temp);

#endif /* ROTATION_H */
