/*************************************/
/* Fichier: rotation.h               */
/* Version: 1.0                      */
/* Date:   January 2010              */
/* Auteur: Didier Pinchon            */
/*************************************/
#ifndef ROTATION_H
#define ROTATION_H

#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <gsl_matrix.h>
#include <gsl_blas.h>

typedef struct S_MATL {
   int lmax;
   gsl_matrix **lmat;
} MatL;

/* matl.c */
extern MatL *matl_calloc(int lmax);
extern void  matl_free(MatL *matl);
extern int   matl_product(const MatL *matl1, const MatL *matl2, MatL *matres);
extern int   matl_product_symm(CBLAS_SIDE_t Side,const MatL *matl1, const MatL *matl2, MatL *matres);

/* rotation */
extern MatL *read_lmatJ(int lmax);
extern int   matl_product_Zalpha_left(const MatL *matl1, const double alpha,MatL *res);
extern int   matl_product_Zalpha_right(const MatL *matl1, const double alpha,MatL *res);
extern int   matl_rotation(int lmax,double alpha, double beta, double gamma,MatL *res,const MatL *matj);

extern  gsl_matrix *read_matJ(int l);
extern int   mat_product_Zalpha_left(int l,const gsl_matrix *matl1, const double alpha,gsl_matrix *res);
extern int   mat_product_Zalpha_right(int l,const gsl_matrix *mat1, const double alpha,gsl_matrix *res);
extern int   mat_rotation(int l,double alpha, double beta, double gamma,gsl_matrix *res,const gsl_matrix *matj);
#endif /* ROTATION_H */
