#include "rotation.h"

int main(int argc, char *argv[])
{
   int lmax,l,i,j,n, iter;
   double x,y,alpha,beta,gamma;
   clock_t t1,t2;
   MatL *matjL, *matrL;
   gsl_matrix *matr,*matj;
   
/* input data */
   lmax = atoi(argv[1]);
   alpha = atof(argv[2]);
   beta  = atof(argv[3]);
   gamma = atof(argv[4]);

/* Recovering J_l matrices for l=1..lmax */
   matjL = read_lmatJ(lmax);

/* 1. Computing all rotation matrices for l=1..lmax using matl_rotation() */
   matrL = matl_calloc(lmax);
   matl_rotation(lmax, alpha, beta, gamma, matrL, matjL);

/* 2. Computing individual rotation matrices J_l for l=2..lmax using mat_rotation() */
   for (l=1;l<=lmax;l++) {
     printf("l = %d\n",l);
     matj = read_matJ(l);
 
     matr = gsl_matrix_calloc(2*l+1,2*l+1);
     mat_rotation(l, alpha, beta, gamma, matr, matj);
    
    /* Comparing with the result previously obtained with matl_rotation() */
       for (i=0;i<=2*l;i++) {
         for (j=0;j<=2*l;j++) {
           x = gsl_matrix_get(matrL->lmat[l],i,j);
           y = gsl_matrix_get(matr,i,j);
           if (x!=y){
             printf("l= %d, x= %20.16e, y= %20.16e\n",l,x,y);
             fprintf(stderr, "Not equality for l = %d\n",l);
           }        
         }
       }
       gsl_matrix_free(matj);
       gsl_matrix_free(matr);
     }

    return EXIT_SUCCESS;
}
